// This source code, executables and programs containing source code or
// binaries or proprietetary technology from the War Software Series are
// NOT alloed used, viewed or tested by any governmental agencies in
// any countries. This includes the government, departments, police, 
// military etc.
// ---
// This file is intended for use with Tab space = 2
// Created and maintained in MSVC Developer Studio
// ---
// NAME			:	FTPDaemon.h
// PURPOSE	: All FTP daemon classes and manifests
// PROGRAM	: War FTP Daemon
// DATE			:	Sept. 21 1996
// AUTHOR		:	Jarle Aase
// ---
// REVISION HISTORY
// 

#ifndef __FTPDAEMONH
#define __FTPDAEMONH

#ifndef __FTPDAEMONCOREH
#include "FTPDaemonCore.h"
#endif


/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
// T O P   L E V E L   C L A S S E S
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////
// Main Thread

class CFTPDaemon : public CDaemonBase
{
	DECLARE_DYNCREATE(CFTPDaemon)
public:
	CFtpDaemonCore *m_FTPD; // Pointer to FTP subsystem

protected:
	CFTPDaemon();    

public:
	virtual void RefreshStats();
	virtual BOOL GoOnline(BOOL Online);

	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFTPDaemon)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CFTPDaemon();

	// Generated message map functions
	//{{AFX_MSG(CFTPDaemon)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////////
// Logging

class CFTPDLog : public CDaemonLog
{
public:
	CFTPDLog();
	~CFTPDLog();
};

/////////////////////////////////////////////////////////////////////////////////
// Remote admin control connection

class CFTPDRemoteAdmin : public CDaemonMaintananceSocket
{
public:
};

/////////////////////////////////////////////////////////////////////////////////
// Remote admin listen socket

class CFTPDRemoteListen : public CDaemonServiceSocket
{
public:
	virtual void OnAccept( int nErrorCode );
	virtual BOOL Initialize(int PortNumber, LPCSTR ServiceName, LPCSTR ListenIP = NULL);

};

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
// G L O B A L   V A R I A B L E S
// Note: All global variables are prefixed with 'g'
/////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

#ifndef EXT
#define EXT extern
#endif

#ifndef EXT
#define EXT extern
#endif

EXT CFTPDLog *gLog;


#endif // __FTPDAEMONH