// This is part of the WAR SOFTWARE SERIES initiated by Jarle Aase
// Copyright 1996 by Jarle Aase. All rights reserved.
// See the "War Software Series Licende Agreement" for details concerning 
// use and distribution.
// ---
// This source code, executables and programs containing source code or
// binaries or proprietetary technology from the War Software Series are
// NOT alloed used, viewed or tested by any governmental agencies in
// any countries. This includes the government, departments, police, 
// military etc.
// ---
// This file is intended for use with Tab space = 2
// Created and maintained in MSVC Developer Studio
// ---
// NAME			:	WarClient.h
// PURPOSE	:	General header file for all War Software that use WarClientLib.dll
// PROGRAM	: 
// DATE			:	Nov. 9 1996
// AUTHOR		:	Jarle Aase
// ---
// REVISION HISTORY
// 

#ifndef __WARCLIENTH
#define __WARCLIENTH

#ifdef DLL_WAR_CLIENT_EXPORT
#define DLL_WAR_CLIENT_ __declspec(dllexport)
#else
#define DLL_WAR_CLIENT_ __declspec(dllimport)
#endif

#ifndef CC_CLIENT
#define CC_CLIENT
#endif

// Include common files
#ifndef __WARSOFTWAREH
#include "WarSoftware.h"
#endif

#ifndef __SHAREDRESOURCEH
#include "sharedresource.h" 
#endif

#include "LogView.h"
#include "MDILogDoc.h"
#include "user.h"
#include "Listvwex.h"


///////////////////////////////////////////////////////////////////////////////////
// Control bar

class DLL_WAR_CLIENT_ CWarToolBar : public CToolBar
{
public:
	CWarToolBar::CWarToolBar(
												 CFrameWnd *pParentWin, 
												 int ResourceID, 
												 LPCSTR Name, 
												 CWarToolBar *pDockLeftOf, 
												 int DocFlags);
	~CWarToolBar();
	BOOL Create();
	void DockControlBarLeftOf();
	static CWarToolBar *FindToolbar(int nID);

	CString m_Name;
	CFrameWnd *m_pParentWnd;
	int m_ResourceID;
	CWarToolBar *m_pDockLeftOf;
	int m_DockFlags;

	static CLinkedList m_Toolbars;
};


DLL_WAR_CLIENT_ BOOL ReadWindowPlacement(LPWINDOWPLACEMENT pwp, LPCSTR KeyName);
DLL_WAR_CLIENT_ void WriteWindowPlacement(LPWINDOWPLACEMENT pwp, LPCSTR KeyName);
DLL_WAR_CLIENT_ void LoadWindowPlacement(CWnd *pWnd, LPCSTR KeyName);
DLL_WAR_CLIENT_ void SaveWindowPlacement(CWnd *pWnd, LPCSTR KeyName);
DLL_WAR_CLIENT_ CString GetWindowText(CWnd *pWnd);

// Sorting flags
#define LV_SORT_NAME	0x0001	// Sort by filename
#define LV_SORT_SIZE	0x0002	// Sort by filesize
#define LV_SORT_DATE	0x0004	// Sort by date
#define LV_SORT_TYPE	0x0008	// Sort by filetype
#define LV_SORT_ASC		0x0010	// Sort ascending

enum // List view modes
{
	LWM_BIG,
	LWM_SMALL,
	LWM_LIST,
	LWM_REPORT
};


extern "C" AFX_EXT_API void WINAPI InitWarClientLibDLL();

#endif /__WARCLIENTH