// This is part of the WAR SOFTWARE SERIES initiated by Jarle Aase
// Copyright 1996 by Jarle Aase. All rights reserved.
// See the "War Software Series Licende Agreement" for details concerning 
// use and distribution.
// ---
// This source code, executables and programs containing source code or
// binaries or proprietetary technology from the War Software Series are
// NOT alloed used, viewed or tested by any governmental agencies in
// any countries. This includes the government, departments, police, 
// military etc.
// ---
// This file is intended for use with Tab space = 2
// Created and maintained in MSVC Developer Studio
// ---
// NAME			:	WarSoftware.h
// PURPOSE	:	General header file for all War Software that use WarSoftwareLib.dll
// PROGRAM	: 
// DATE			:	Sept. 19 1996
// AUTHOR		:	Jarle Aase
// ---
// REVISION HISTORY
// 

#ifndef __WARSOFTWAREH
#define __WARSOFTWAREH

#ifdef DLL_WAR_SOFTWARE_EXPORT
#define DLL_WAR_SOFTWARE_ __declspec(dllexport)
#else
#define DLL_WAR_SOFTWARE_ __declspec(dllimport)
#endif

#ifdef DLL_WAR_DAEMON_EXPORT
#define DLL_WAR_DAEMON_ __declspec(dllexport)
#else
#define DLL_WAR_DAEMON_ __declspec(dllimport)
#endif

#ifndef __SHAREDRESOURCEH
#include "sharedresource.h" 
#endif

class CFTPDataSock;
class CDaemonEvent;
class CLog;
class CSock;
class CTextSock;
class CCommandParser;

// Include common files
#include "MiscSupport.h"
#include "options.h"
#include "WarSMemory.h"
#include "WarFsys.h"

extern "C" AFX_EXT_API void WINAPI InitWarSoftwareLibDLL();

#ifndef __WARDAPIH
#include "DaemonAPI.h"
#endif __WARDAPIH


/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
// U S E F U L   B A S I C   M A C R O S
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// Return the offset to a data member in a class/structure
// Returns (&DataMember - this)
#define GetMemberOfs(DataMember)\
 (((DWORD)(LPVOID)&DataMember) - ((DWORD)(LPVOID)this))

enum // Base datatypes 
{
	DATATYPE_CSTRING,
	DATATYPE_INT,
	DATATYPE_BOOL,
	DATATYPE_LPSTR,
	DATATYPE_INVALID
};

typedef struct sMacroTable
{
	char *Name;			// Macro name
	int	Symb;				// Symbole
	char *Descr;		// Description
} MACROTABLE; 



#include "WarSoftwareLib.h"
#include "remoteinterface.h"


/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
// E N U M S   U S E D   B E T W E E N   M O D U L E S
/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////


enum // TIMERS
{
	TIMER_POLL = 1,		// Polls each second
	TIMER_SCHDLDLG,   // Timer for scheduled event in a dialog
	TIMER_INVALID
};

enum // User messages
{
	WMU_RCTDREQ = WM_USER +10,  // Remote client to daemon request
	WMU_DNS,	// DNS lookup from control socket class
	WMU_MSG, // NT Service messages
	WMU_SNM, // Shell notify icon
	WMU_LOGGEDLINE,
	WMU_TX_DNS,
	WMU_PROCESS,
	WMU_COMMAND, // Command to be executed in LPARAM
	WMU_SET_STATUSBAR_TEXT,
	WMU_MDI_CHANGE,
	WMU_INVALID
};


#endif // __WARSOFTWAREH
