

#ifndef __DAEMONINFOH
#define __DAEMONINFOH

#ifndef __WARCLIENTH
#include "WarClient.h"
#endif

class DLL_WAR_CLIENT_ CDaemonInfo : public CObject
{
public:
	DECLARE_SERIAL(CDaemonInfo)
	CDaemonInfo();
	~CDaemonInfo();
	LPCSTR GetServiceName();
	void Serialize(CArchive& ar);

	CString m_Domain;
	CString m_User;
	CString m_Passwd;
	CString m_Home;
	CString	m_LocalPath; // Used for Inet pane to simplify local path.

	int m_Type; // Server type
	int m_Port;
	int m_Retries;
	int m_RetryDelay; // Seconds
	int m_LoginMode;
	BOOL m_Loop;

	int m_UsePasv;

	int m_Version;
};


enum // LOGIN MODES
{
	LM_ANONYMOUS,
	LM_USER,
	LM_INVALID
};

enum // SERVER TYPES
{
	ST_FTP,
	ST_HTTP,
	ST_LOCAL,
	ST_INVALID
};

#define DI_CURRENT_VERSION 1
/////////////////////////////////////////////////////////////////////////////
// CDaemonInfoDlg dialog

class CDaemonInfoDlg : public CPropertyPage
{
	DECLARE_DYNCREATE(CDaemonInfoDlg)

// Construction
public:
	CDaemonInfoDlg(CDaemonInfo *pInfo = NULL);
	~CDaemonInfoDlg();
	void ParseURL();
	CDaemonInfo *m_pInfo;

#ifdef DLL_WAR_CLIENT_EXPORT
// Dialog Data
	//{{AFX_DATA(CDaemonInfoDlg)
	enum { IDD = IDD_DAEMON_INFO_TAB };
	CComboBox	m_ctlServerTypeCB;
	//}}AFX_DATA
#endif


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CDaemonInfoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CDaemonInfoDlg)
	afx_msg void CheckStates();
	afx_msg void OnKillfocusDomain();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};
/////////////////////////////////////////////////////////////////////////////
// CDaemonInfoTab

class DLL_WAR_CLIENT_ CDaemonInfoTab : public CPropertySheet
{
	DECLARE_DYNAMIC(CDaemonInfoTab)

// Construction
public:
	CDaemonInfoTab(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CDaemonInfoTab(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDaemonInfoTab)
	public:
	virtual int DoModal(CDaemonInfo *pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDaemonInfoTab();

	// Generated message map functions
protected:
	//{{AFX_MSG(CDaemonInfoTab)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////


#endif __DAEMONINFOH
