// GenericInternetMDI.h : header file
//

class CCaptionBar;
class CGenericInternetView;
class CFTPCxferBar;

/////////////////////////////////////////////////////////////////////////////
// CGenericInternetMDI frame

class DLL_WAR_CLIENT_ CGenericInternetMDI : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CGenericInternetMDI)
protected:
	CGenericInternetMDI();           // protected constructor used by dynamic creation

public:
	BOOL IsReady();
	BOOL IsOnline();
	void CreateXferBar(CGenericInternetView *pMaster);
	static void OnIdle();
	void _OnIdle();

// Attributes
public:
		CSplitterWnd m_Split; // Splitter that cuts between server / log
		CSplitterWnd m_FileSplit; // Local and server file views
		CSplitterWnd m_LogSplit; // Local and server log views
		CCaptionBar *m_Caption;
		CGenericInternetView *m_ActivePart; // The active connection view
		static CWarToolBar *m_pFTPtoolbar;
		static int FramesCnt;
		int m_TransferMode; // Ascii, bin, auto
		BOOL m_DoResume;
		BOOL m_Virgin;
		CString m_StoredMessage;
		CFTPCxferBar *m_pXferBar;
		CGenericInternetView *m_pMasterForXfer;
		CWarTimer m_Timer;
		BOOL m_SplittersIsInitialized;
		static CLinkedList m_Frames;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGenericInternetMDI)
	public:
	virtual void ActivateFrame(int nCmdShow = -1);
	virtual void RecalcLayout(BOOL bNotify = TRUE);
	protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CGenericInternetMDI();

	// Generated message map functions
	//{{AFX_MSG(CGenericInternetMDI)
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnModeAuto();
	afx_msg void OnUpdateModeAuto(CCmdUI* pCmdUI);
	afx_msg void OnModeBinary();
	afx_msg void OnUpdateModeBinary(CCmdUI* pCmdUI);
	afx_msg void OnModeText();
	afx_msg void OnUpdateModeText(CCmdUI* pCmdUI);
	afx_msg void OnDoResume();
	afx_msg void OnUpdateDoResume(CCmdUI* pCmdUI);
	afx_msg void OnDestroy();
	afx_msg void OnConnect();
	afx_msg void OnUpdateConnect(CCmdUI* pCmdUI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////


enum // Transfere modes
{
	TFN_AUTO,
	TFM_BINARY,
	TFN_ASCII
};
