// MDILogDoc.h : header file
//

class CClientLog;

/////////////////////////////////////////////////////////////////////////////
// CMDILogDoc document

class DLL_WAR_CLIENT_ CMDILogDoc : public CDocument
{
public:
	static void AddLogLine(LPCSTR Text);
	static CMDILogDoc *m_pMyLog;
	static CMultiDocTemplate *m_pMyTemplate;

protected:
	CMDILogDoc();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CMDILogDoc)
	static void Declare();
	static CClientLog *GetLog();

// Attributes
public:
	static CMDILogDoc *CreateLogDoc();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMDILogDoc)
	public:
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
	virtual BOOL CanCloseFrame(CFrameWnd* pFrame);
	virtual void OnCloseDocument();
	protected:
	virtual BOOL OnNewDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMDILogDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CMDILogDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CClientLog - Spesific routines for logging to clients

class DLL_WAR_CLIENT_ CClientLog : public CLog
{
public:
	static CClientLog *m_pLog;

public:

	CClientLog();
	~CClientLog();

	static CClientLog *GetLog() { return m_pLog; }
	virtual void LoggedLine(int LogType, LPCSTR Line);
};

/////////////////////////////////////////////////////////////////////////////
// LogMsg - Used to log from mudules without own log handling

DLL_WAR_CLIENT_ void LogMsg(int flag, LPCSTR Format, ...);

